C--------------------------------------------------------
C	convert a flux of integers to a .WAV file
C	1st arg:  'M' for monophonic
C		  'S' for stereo
C	2nd arg:  output file name
C
C	http://tontonth.free.fr/sound77.html
C
C--------------------------------------------------------
	program int77wav

C	Variables
	character*80	fname
	integer		filenumber
	character	option
	integer		samplerate, nbrchann
	integer*2	sample

C	Prototypes
	integer		sndfopen

C	sanity check on the command line
	if (IARGC() .ne. 2) call EXIT(1)
	call GETARG(1, option)
	if ((option.ne.'M').and.(option.ne.'S')) call EXIT(4)

	call GETARG(2, fname)
	
C	assume that we work on cdrom, hey...

	samplerate = 44100

	if (option .eq. 'M') nbrchann = 1
	if (option .eq. 'S') nbrchann = 2

	filenumber = sndfopen(fname, 'O', samplerate, nbrchann)
	if (filenumber .lt. 0) then
	    call exit(1)
	endif

	if (option .eq. 'M') call tx_mono(filenumber)
	if (option .eq. 'S') call tx_stereo(filenumber)

	end
C--------------------------------------------------------
	subroutine tx_mono(fnum)
	integer		fnum
	integer*2	sample
	do
	    read(5,101, END=200) sample
	    call sndfput(fnum, sample)
	enddo
200	continue
101	format(i10)
	end
C--------------------------------------------------------
	subroutine tx_stereo(fnum)
	integer	fnum
	integer*2	sleft, sright
	do
	    read(5,102, END=200) sleft, sright
	    call sndfput2(fnum, sleft, sright)
	enddo
200	continue
102	format(2i10)
	end
C--------------------------------------------------------
