#!/bin/bash

rm valgrind.pid* toto.err

PROG=s77decomp

make -j 2 $PROG
if [ $? != 0 ]; then
	echo "=============PAN============="
	exit 1
fi

echo
echo "Start Valgrinding..."

valgrind  --tool=memcheck  --log-file=valgrind --show-reachable=yes	\
	  --leak-check=yes						\
	./$PROG								\
	2> toto.err

LOG=`ls -rt valgrind.pid*`

vim -o $LOG toto.err
