C--------------------------------------------------------
C	s77reverb - my third sound filter 
C	http://tontonth.free.fr/sound77.html
C--------------------------------------------------------
	program s77reverb

	integer		tbuff
	parameter	(tbuff=250000)

	integer*2	sleft, sright
	integer*2	dleft, dright
	integer*2	tbleft(tbuff),tbright(tbuff)
	integer		idx, foo, param, delay
	integer		fnin, fnout, smplrate, nbchann
	character*20	chaine
	character*100	infname, outfname

C----	prototypes
	integer		sndfopen,sndfget2,sndfget

C----	Initialisations
	do 10 foo=1,tbuff
	    tbleft(foo) = 0
	    tbright(foo) = 0
10	continue

	if (IARGC() .ne. 3) then
	    print *,'Erreur arguments: infile NNN(ms) outfile'
	    call exit(1)
	end if

C----	get and decode parameters
	call getarg(1, infname)
	call getarg(2, chaine)
	read(chaine,*) param
	call getarg(3, outfname)

C----	open input file
	fnin = sndfopen(infname, 'I', smplrate, nbchann)
	if (fnin .lt. 0) then
	    write(6, 50) fnin
	    call exit(2)
	end if
50	format('Err open infile', i5)

C----	create output wavfile
	fnout = sndfopen(outfname, 'O', smplrate, nbchann)
	if (fnout .lt. 0) then
	    write(6, 51) fnout
	    call exit(2)
	end if
51	format('Err open outfile', i5)

	delay = (smplrate * param) / 1000
	if (delay .ge. tbuff) then
	    call exit(1)
	endif

	write(6,52) smplrate, nbchann, param, delay
52	format('s77reverb: ', i8, ':', i1, ',  ', i5, 'ms  ',  i7, 'bk')

	if (nbchann .eq. 1) goto 200

C----	stereophonic reverberation
	idx = 1
	do
	    foo = sndfget2(fnin, sleft, sright)
	    if (foo .ne. 2) goto 201
	    dleft = ((5 * sleft) + (4*tbleft(idx))) / 9
	    dright = ((5 * sright) + (4*tbright(idx))) / 9
	    tbleft(idx) = dleft
	    tbright(idx) = dright
	    idx = idx + 1
	    if (idx .eq. delay) idx = 1
	    call sndfput2(fnout, dleft, dright)
	enddo
201	continue
	goto 999

C----	monophonic reverberation
200	continue
	idx = 1
	do
	    foo = sndfget(fnin, sleft)
	    if (foo .ne. 1) goto 202
	    dleft = ((5*sleft) + (4*tbleft(idx))) / 9
	    tbleft(idx) = dleft
	    idx = idx + 1
	    if (idx .eq. delay) idx = 1
	    call sndfput(fnout, dleft)
	enddo
202	continue

999	continue

	call sndfclose(fnin)
	call sndfclose(fnout)

	end
C--------------------------------------------------------
