C--------------------------------------------------------
C	s77stats - compute some numbers on a .WAV file
C	http://tontonth.free.fr/sound77.html
C--------------------------------------------------------
	program s77stats

	integer*2	sleft, sright
	integer*2	aleft, aright
	integer*2	maxlf, maxrh
	integer		fnin, smplrate, nbchann
	integer		foo, idx
	character*100	infname

C----	prototypes
	integer		sndfopen,sndfget2,sndfget

	if (IARGC() .ne. 1) then
	    print *,'Erreur arguments: manque non fichier .WAV'
	    call exit(1)
	end if

C----	get and decode parameters
	call getarg(1, infname)

C----	open input file
	fnin = sndfopen(infname, 'I', smplrate, nbchann)
	if (fnin .lt. 0) then
	    write(6, 50) fnin
	    call exit(2)
	end if
50	format('Err open infile', i5)

	write(6,52) smplrate, nbchann
52	format('sample rate', i8, ' Hz, ', i3, ' channels')

	if (nbchann .eq. 1) goto 300

C----	stereophonic analysis
      maxlf = 0
      maxrh = 0
      idx = 1
      do
          foo = sndfget2(fnin, sleft, sright)
          if (foo .ne. 2) goto 201
          aleft = abs(sleft)
          if (aleft .gt. maxlf) maxlf = aleft
          aright = abs(sright)
          if (aright .gt. maxrh) maxrh = aright
      enddo
201   continue
      write (6, 202) maxlf, maxrh
202   format ('maximums: ', 2i8)
      goto 999

C----	monophonic analysis
300	continue
	idx = 1
	do
	    foo = sndfget(fnin, sleft)
	    if (foo .ne. 1) goto 302
	enddo
302	continue

999	continue

	call sndfclose(fnin)

	end
C--------------------------------------------------------
