C------------------------------------------------------------------------
C	Just set the buffer to zero
	subroutine wavf00(buff, nbs)
	integer			nbs
	integer*2		buff(nbs)
	integer			step
	do 10 step=1, nbs
	    buff(step) = 0
10	continue
	end
C------------------------------------------------------------------------
C
C	What are the parameters ?
C	~~~~~~~~~~~~~~~~~~~~~~~~~
C	buff:	an array of integer*2 who hold the samples.
C	nbs:	size of the buffer.
C	freq:	base frequency of the sound.
C	sr:	sample rate, eg: 44100
C
	subroutine  wavf01(buff, nbs, freq, sr)
	integer			nbs
	integer*2		buff(nbs)
	double precision	freq
	integer			sr

	integer			step
	double precision	dt, val, k, freqcoef
	integer*2		sample

	k = freqcoef(freq, sr)
	do 10 step=1, nbs
	    dt = dble(step-1) * k
	    val = sin(dt) * cos(dt*3.0d0) 
	    sample = int(val*32500)
	    buff(step)=sample
C	    write(6,20) step, val, sample
10	continue
20	format(i6, f8.4, i7)
	end
C------------------------------------------------------------------------
	subroutine  wavf02(buff, nbs, freq, sr)
	integer			nbs
	integer*2		buff(nbs)
	double precision	freq
	integer			sr

	double precision	freqcoef, k
	double precision	dt, val
	integer			step
	integer*2		sample

	k = freqcoef(freq, sr)
	do 10 step=1, nbs
	    dt = dble(step) * k
	    val = (4.0*sin(dt)) + sin(dt*2.0) + sin(dt*4.00)
	    val = val / 6.0d0
	    sample = int(val*32500d0)
	    buff(step)=sample
10	continue

	end
C------------------------------------------------------------------------
	subroutine  wavf03(buff, nbs, freq, sr)
	integer			nbs
	integer*2		buff(nbs)
	double precision	freq
	integer			sr

	double precision	freqcoef, k
	double precision	dt, val
	integer			step
	integer*2		sample

	k = freqcoef(freq, sr)
	do 10 step=1,nbs
	    dt = dble(step) * k
	    val = sin(dt) + sin(dt*2.004) + sin(dt*3.008) + sin(dt*5.012)
	    sample = int((val/4.0)*32500)
	    buff(step)=sample
10	continue
	end
C------------------------------------------------------------------------

	subroutine  wavf04(buff, nbs, freq, sr)
	integer			nbs
	integer*2		buff(nbs)
	double precision	freq
	integer			sr

	double precision	freqcoef, k
	double precision	dt, val
	integer			step
	integer*2		sample

	k = freqcoef(freq, sr)
	do 10 step=1,nbs
	    dt = dble(step) * k
	    val = sin(dt) 
	    if (val .lt. 0.0) then
	        sample =  int(val*30000)
	    else
		sample = -int(val*30000)
	    endif
	    buff(step)=sample
10	continue

	end
C------------------------------------------------------------------------
